[![Build Status](https://travis-ci.org/stefanwalther/qliksense-extension-tutorial.svg?branch=master)](https://travis-ci.org/stefanwalther/qliksense-extension-tutorial)
# Qlik Sense Extension Tutorial

A comprehensive Qlik Sense Extension Tutorial

## About this Tutorial

In this tutorial you'll learn how to use Qlik Sense' Extension concept to bring new visualizations into the Qlik Sense Client.

### Work in Progress, Always

This project is work in progress and will and should always remain in this status, that's part of the concept and the idea of creating a ***living tutorial***. As soon as there are now capabilities exposed in Qlik Sense' Extension API, I will update the appropriate sections here.

If you want to follow the progress of this project there are some options:

* [Join GitHub](https://github.com/join) and "Watch" this project
* [Follow me on Twitter](http://twitter.com/waltherstefan), as soon as I have finished a new chapter, I'll announce it there

## Chapters

These are the chapters I am about to write ... and some of them are already finished ;-)

* [00 About this Tutorial](tutorial/00-About.md)
* [01 Qlik Sense Extension Tutorial](tutorial/01-Qlik-Sense-Extension-Tutorial.md)
* [02 Introduction to Qlik Sense Visualization Extensions](tutorial/02-Introduction-to-Qlik-Sense-Visualization-Extensions.md)
* [03 Let's Get Started: Hello World Example](tutorial/03-Lets-Get-Started--Hello-World-Example.md)
* [04 Debugging and Web Developer Tools] (tutorial/04-Debugging-and-Web-Developer-Tools.md)
* 05 Improving the Web Hello World Experience
* 07 An Introduction to Custom Properties
* 08 More on Custom Properties
* 09 Working with Data
* 10 Including External Resources
* 11 More on  HyperCubes
* 11 The BackendAPI
* 12 The Selection Model
* 13 Working with Variables
* 14 Working with a ListObjectDefinition
* 15 Working with a PivotTableDefinition
* 16 Working with Meta Data
* 17 Talking to the Repository API
* 18 Setting up a Robust Development Environment
* 19 Two Approaches, the “Classic” One & the Angular Way
* Appendix:
	* [Resources](tutorial/1001-Appendix-Resources.md)
	* branch.qlik.com
	* Basic Introduction to git & GitHub
	* How to publish your extension to GitHub & branch.qlik.com
	* Npm Integration
	* Programmatic Deployment of Qlik Sense Extensions
	* What's New
		* [What's New in Qlik Sense 1.1](tutorial/2011-Appendix-Whats-New-in-Qlik-Sense-1.1.md)
	* Qlik Sense Extension Related Resources
* Tools
	* Tools: Manage Your Extensions


## Comments, Feedback & Questions

If you have any questions, found errors, etc., please [create an issue here on GitHub](https://github.com/stefanwalther/qliksense-extension-tutorial/issues).

## Contributing

Found a bug? Have a request? Have a question?
Please [create an issue](https://github.com/stefanwalther/qliksense-extension-tutorial/issues) on GitHub.

## Errata
Due to the nature of this project there is no errata section necessary: This is living tutorial, so as soon as I find errors or mistakes or just want to improve something, I'll just fix it and push it to GitHub.

By doing so, you'll always have access to the latest version.

If you want to follow changes, follow the [Change Log](CHANGELOG.md).


## Author

**Stefan Walther**

* [github.com/stefanwalther](http://github.com/stefanwalther)
* [twitter.com/waltherstefan](http://twitter.com/waltherstefan)
* [qliksite.io](http://qliksite.io)

## License

This tutorial is made available "AS IS" without any warranty of any kind under the MIT License (MIT).

[Additional license information for this tutorial](https://github.com/stefanwalther/qliksense-extension-tutorial/blob/master/LICENSE.md).
